﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace CreateEmployeeExample
{
    class Program
    {
        static string sURI = "https://secureapi.smarttid.dk/wsAPISmartTID.asmx";
        static void Main(string[] args)
        {
            string sAPIKey = "XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX"; // this must be replaced with a valid APIKey
            string sEmployeeCode = "Test1234";
            string sName = "Test";
            string sEmployedStartDate = "2019-03-01";
            string sTemplateCode = "TemplateCode1";
            CreateEmployee(sAPIKey, sEmployeeCode, sName, sEmployedStartDate, sTemplateCode);
        }
        private static void CreateEmployee(string sAPIKey, string sEmployeeCode, string sName, string sEmployedStartDate, string sTemplateCode)
        {
            using (var client = new HttpClient())
            {
                var request = new HttpRequestMessage()
                {
                    RequestUri = new Uri(sURI),
                    Method = HttpMethod.Post
                };

                request.Content = new StringContent(GetCreateEmployeeSOAPString(sAPIKey, sEmployeeCode, sName, sEmployedStartDate, sTemplateCode), Encoding.UTF8, "text/xml");

                request.Headers.Clear();
                client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("text/xml"));
                request.Content.Headers.ContentType = new MediaTypeHeaderValue("text/xml");
                request.Headers.Add("SOAPAction", "http://api.smarttid.dk/CreateEmployee");

                HttpResponseMessage response = client.SendAsync(request).Result;

                if (!response.IsSuccessStatusCode)
                {
                    throw new Exception();
                }

                Task<Stream> streamTask = response.Content.ReadAsStreamAsync();
                Stream stream = streamTask.Result;
                StreamReader reader = new StreamReader(stream);
                string str = reader.ReadToEnd();
                Console.WriteLine(str);
                Console.ReadLine();

            }
        }
        private static string GetCreateEmployeeSOAPString(string sAPIKey, string sEmployeeCode, string sName, string sEmployedStartDate, string sTemplateCode)

        {
            string startSoapEnvelopeString = @"<?xml version=""1.0"" encoding=""utf-8""?>
                                    <soap:Envelope xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"">
                                    <soap:Body>";
            string parameterString = @"<CreateEmployee xmlns=""http://api.smarttid.dk/"">";
            if (sAPIKey != "")
            {
                parameterString = parameterString + "<sAPIKey>" + sAPIKey + "</sAPIKey>";
            }
            if (sEmployeeCode != "")
            {
                parameterString = parameterString + "<sEmployeeCode>" + sEmployeeCode + "</sEmployeeCode>";
            }
            if (sName != "")
            {
                parameterString = parameterString + "<sName>" + sName + "</sName>";
            }
            if (sEmployedStartDate != "")
            {
                parameterString = parameterString + "<sEmployedStartDate>" + sEmployedStartDate + "</sEmployedStartDate>";
            }
            if (sTemplateCode != "")
            {
                parameterString = parameterString + "<sTemplateCode>" + sTemplateCode + "</sTemplateCode>";
            }
            parameterString = parameterString + "</CreateEmployee>";

            string endSoapEnvelopeString= "</soap:Body></soap:Envelope>";

            string argumentString = startSoapEnvelopeString + parameterString + endSoapEnvelopeString;
            return argumentString;
        }
    }
}
